from __future__ import annotations

from dataclasses import dataclass

from sziszapangma.core.alignment.step_type import StepType
from sziszapangma.core.alignment.step_words import StepWords


@dataclass(frozen=True)
class AlignmentStep:
    step_type: StepType
    step_words: StepWords
    step_cost: float

    def with_weight_multiplication(self, weight: float) -> AlignmentStep:
        return AlignmentStep(
            step_type=self.step_type, step_words=self.step_words, step_cost=self.step_cost * weight
        )
