from enum import Enum


class StepType(Enum):
    CORRECT = 1
    SUBSTITUTION = 2
    DELETION = 3
    INSERTION = 4

    def get_short_name(self) -> str:
        return self.name[:3]

    def is_cross_step(self) -> bool:
        return self in [StepType.CORRECT, StepType.SUBSTITUTION]

    def contain_reference_word(self) -> bool:
        return self != StepType.INSERTION
