from __future__ import annotations

import uuid
from dataclasses import dataclass


@dataclass(frozen=True)
class Word:
    id: str
    value: str

    @classmethod
    def from_string(cls, string: str) -> Word:
        return cls(str(uuid.uuid4()), string)

    def to_lower(self) -> Word:
        return Word(self.id, self.value.lower())
