from abc import ABC, abstractmethod
from typing import Dict, List

import numpy as np
import numpy.typing as npt


class EmbeddingTransformer(ABC):
    @abstractmethod
    def get_embeddings(self, words: List[str]) -> Dict[str, npt.NDArray[np.float64]]:
        pass

    @abstractmethod
    def get_embedding(self, word: str) -> npt.NDArray[np.float64]:
        pass
