from dataclasses import dataclass
from typing import List


@dataclass(frozen=True)
class Span:
    index_start: int
    index_end: int

    def is_index_belong(self, index: int) -> bool:
        return self.index_start <= index < self.index_end

    def get_reference_mask_table(self, total_size: int) -> List[bool]:
        return [self.is_index_belong(it) for it in range(total_size)]
